define( function() {
"use strict";

function Control()
{
};

Control.prototype.draw = function( oControlHost )
{
	var o = oControlHost.configuration || {};
	var el = oControlHost.container;
	var v_iHeight = ( o.Height || el.offsetHeight );
	var v_iWidth = ( o.Width || el.offsetWidth );
	var v_bPositionOnTheRight = ( o.Position == "Right" );
	var sSourceType = o["Source Type"] || "Text";
	var sSelector = "#" + el.id;
	var sStyle =
		'<style>' +
		sSelector + ' svg' +
		'{' +
			'fill:' + ( o["Fill"] || "#6D7777" ) + ';' +
		'}' +
		sSelector + ' svg:hover' +
		'{' +
			'fill:' + ( o["Hover Fill"] || "#4178BE" ) + ';' +
		'}' +
		sSelector + ' DIV' +
		'{' +
			'cursor: default;' +
			'visibility: hidden;' +
			'position: absolute;' +
			( ( o["Box Shadow"] !== false ) ? 'box-shadow:0 1px 5px rgba(0, 0, 0, 0.25);' : '' ) +
			'margin: ' + ( v_bPositionOnTheRight ? '0' : v_iHeight ) + 'px 0 0 ' + ( v_bPositionOnTheRight ? v_iWidth : '0' ) + 'px;';
		if ( sSourceType == "Text" )
		{
			sStyle +=
			'max-width: ' + ( o["Max Width"] || 300 ) + 'px;' +
			'padding: 2px 4px 2px 4px;' +
			'border-radius: 2px;' +
			'border: 1px solid ' + ( o["Border Color"] || '#E6E7E8' ) + ';' +
			'color: ' + ( o["Font Color"] || '#444444' ) + ';' +
			'background-color: ' + ( o["Background Color"] || '#F2F2F2' ) + ';' +
			( o["Font Family"] ? ( 'font-family:' + o["Font Family"] + ';' ) : '' ) +
			( o["Font Size"] ? ( 'font-size:' + o["Font Size"] + ';' ) : '' );
		}
		sStyle +=
		'}' +
		sSelector + ':hover DIV { visibility:visible; }' +
		'</style>';
	
	var sSvgIcon = o["SVG Icon"] || '<svg xmlns="http://www.w3.org/2000/svg" width="' + v_iWidth + 'px" height="' + v_iHeight + 'px" viewBox="0 0 16 16"><path d="M8.5 11L8.5 6.5 6.5 6.5 6.5 7.5 7.5 7.5 7.5 11 6 11 6 12 10 12 10 11zM8 3.5c-.4 0-.8.3-.8.8S7.6 5 8 5c.4 0 .8-.3.8-.8S8.4 3.5 8 3.5z" /><path d="M8,15c-3.9,0-7-3.1-7-7s3.1-7,7-7s7,3.1,7,7S11.9,15,8,15z M8,2C4.7,2,2,4.7,2,8s2.7,6,6,6s6-2.7,6-6S11.3,2,8,2z" /></svg>';
	var sSource = o.Text || "";
	if ( !sSource && this.m_oDataStore )
	{
		sSource = this.m_oDataStore.getFormattedCellValue( 0, 0 );
	}
	switch ( sSourceType )
	{
		case "Text":
			sSource = this.HTMLEncode( sSource );
			break;

		case "URL":
			sSource = '<img src="' + sSource + '"/>';
			break;
	}
	el.innerHTML = sStyle + '<DIV>' + sSource + '</DIV>' + sSvgIcon;
};

Control.prototype.setData = function( oControlHost, oDataStore )
{
	this.m_oDataStore = oDataStore;
};

Control.prototype.HTMLEncode = function( s )
{
	return String( s ).replace( /&/g, "&amp;" ).replace( /</g, "&lt;" ).replace( />/g, "&gt;" );
};

return Control;
});
